// JSlide v2, Web Slide Show
// Copyright (C) 2000, Ted Felix

// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

// Or see their website: http://www.gnu.org/copyleft/gpl.html
// The file gpl.txt should be included with the package that contained
// this file.

// You can contact the author at: http://tedfelix.com


// Globals passed from show() to imgload2()
var NewSlideDiv;
var OldSlideDiv;
var NewCaption;

// Global passed from imgload() to imgload2()
var imgImageSize;

function imgclick()
{
	// Switch to just the full image in the browser
	window.navigate(imagesize.src);
}

// Resize the img to fit the div, and center it.
//   Img: image with real size
//   SlideDiv: Div containing the image to resize to fit the div
function ResizeSlide(SizeImg, SlideDiv)
{
	// Get the div width and height
	var DivWidth = SlideDiv.style.width;
	var DivHeight = SlideDiv.style.height;

	// Remove "px" from the end
	DivWidth = DivWidth.substr(0, DivWidth.length - 2);
	DivHeight = DivHeight.substr(0, DivHeight.length - 2);

	// Get the image to resize
	var SlideImg = document.all.item(SlideDiv.id + "i");  // Must be DIVIDi

	// Get the image width and height
	var Height = SizeImg.height;
	var Width = SizeImg.width;

	// If the image doesn't fit in the div
	if (Height > DivHeight  ||  Width > DivWidth)
	{
		// rescale it to fit, maintaining aspect ratio
		var Ratio = Height/Width;

		// set new height
		Height = DivHeight;
		// compute new width
		Width = Height / Ratio;

		// if still too big
		if (Width > DivWidth)
		{
			// set new width
			Width = DivWidth;
			// compute new height
			Height = Width * Ratio;
		}

		SlideImg.height = Height;
		SlideImg.width = Width;
	}

	// Center the image
	ImgLeft = DivWidth / 2 - Width / 2;
	ImgTop = DivHeight / 2 - Height / 2;

	SlideImg.style.left = ImgLeft;
	SlideImg.style.top = ImgTop;
}

// The hidden image kicks this off.
function imgload()
{
	var Img = window.event.srcElement;

	// Save this for imgload2()
	imgImageSize = Img;

	// If nothing is really loaded yet
	if (Img.src == "nothing.jpg")
		return;

	// Load the image where it belongs
	var NewSlideImg = document.all.item(NewSlideDiv.id + "i");  // Must be DIVIDi
	NewSlideImg.src = Img.src;

	// This will then kick off imgload2() after the image is loaded.
}

// Stage 2 of image loading.  
function imgload2()
{
	// At this point both the hidden image for determining image size is
	// loaded, and the real image we are going to display is loaded too.
	// So now we can resize the image and display it.

	var Img = window.event.srcElement;

	// If nothing is really loaded yet
	if (Img.src == "nothing.jpg")
		return;

	// Resize it to fit the div
	ResizeSlide(imgImageSize, NewSlideDiv);

	// Bring the new slide to the front, but hidden.
	OldSlideDiv.style.zIndex = 1;
	NewSlideDiv.style.visibility = "hidden";
	NewSlideDiv.style.zIndex = 2;

	// Transition 12 is random dots, 21/22 random lines
	// Investigate DirectX Fade Transform (DXImageTransform.Microsoft.Fade)

	// Transitions bomb now.  Perhaps because transition occurs in onload()
	// of transitioning div?

	// Freezes the status of the item to allow setup of the destination status
//	NewSlideDiv.filters[0].Apply();

	// Make the new slide visible
	NewSlideDiv.style.visibility = "visible";
	NewSlideDiv.filters.revealTrans.transition=12;

	// Run the transition
//	NewSlideDiv.filters[0].Play();

	// Now that the slide is visible, update the caption
	caption.innerText = NewCaption;
}

// This variable flips between 0 and 1 each time a slide is displayed.
// This lets show() alternate between the two divs/imgs.
var SlideSwap = 0;

// Show a specific slide from a slide show
function show(SlideArray, num) 
{
	var idOldSlide = "slide" + (SlideSwap + 1);

	// Figure which slide div to use
	SlideSwap++;
	if (SlideSwap > 1)
		SlideSwap = 0;

	var idNewSlide = "slide" + (SlideSwap + 1);

	// Set up the divs for imgload2()
	NewSlideDiv = document.all.item(idNewSlide);
	OldSlideDiv = document.all.item(idOldSlide);

	// Save the new caption for after the new slide is visible
	NewCaption = SlideArray[num * 2 + 1];
//	caption.innerText = "";

	// Load the image in the temporary image size measuring img tag
	imagesize.src = SlideArray[num * 2];

	// I do that because I couldn't figure out how to "reset" the height
	// and width of an img tag with DHTML so that when a new image is
	// loaded (by changing the "src") height amd width are set to the
	// size of this new image.  Once you set the height and width with
	// DHTML, it stays that way.  So instead I use a temporary img tag
	// whose height/width I never touch.  That way, it always has the
	// height and width of the actual image.

	// This will kick off imgload() after the image is loaded.
}

var SlideNum = 0;

// Go to the next slide
function NextSlide()
{
	// Figure out the next slide's index
	var SlideIndex = SlideNum % (Slides.length / 2);

	// Show the next slide
	show(Slides, SlideIndex);

	// Bump the slide counter
	SlideNum++;

	// Setup a timer for the next slide
	timerID = window.setTimeout("NextSlide()", 5000);
}

// Play the first slide
NextSlide();
